OpenTTD: NWidgetStacked Class Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Data Fields
NWidgetStacked Class Reference

Stacked widgets, widgets all occupying the same space in the window. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetStacked:

## Public Member Functions
| NWidgetStacked ()
| Widgets stacked on top of each other.
void | SetIndex (int index)
void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget.
void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
void | FillNestedArray (NWidgetBase **array, uint length)
void | Draw (const Window *w)
| Draw the widgets of the tree.
NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.
void | SetDisplayedPlane (int plane)
| Select which plane to show (for NWID_SELECTION only).
Public Member Functions inherited from NWidgetContainer
| NWidgetContainer (WidgetType tp)
| Constructor container baseclass.
void | Add (NWidgetBase *wid)
| Append widget wid to container.
bool | IsEmpty ()
| Return whether the container is empty.
NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type.
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor.
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted (TextColour highlight_colour)
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget.
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step.
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step.
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint).
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Data Fields
int | shown_plane
| Plane being displayed (for NWID_SELECTION only).
int | index
| If non-negative, index in the Window::nested_array.

## Additional Inherited Members
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position.
Protected Attributes inherited from NWidgetContainer
NWidgetBase * | head
| Pointer to first widget in container.
NWidgetBase * | tail
| Pointer to last widget in container.

## Detailed Description

Stacked widgets, widgets all occupying the same space in the window.

NWID_SELECTION allows for selecting one of several panels (planes) to tbe displayed. All planes must have the same size. Since all planes are also initialized, switching between different planes can be done while the window is displayed.

There are also a number of special planes (defined in StackedZeroSizePlanes) that have zero size in one direction (and are stretchable in the other direction) or have zero size in both directions. They are used to make all child planes of the widget disappear. Unlike switching between the regular display planes (that all have the same size), switching from or to one of the zero-sized planes means that a #Windows::ReInit() is needed to re-initialize the window since its size changes.

Definition at line 405 of file widget_type.h.

## Member Function Documentation

void NWidgetStacked::AssignSizePosition | ( | SizingType | sizing,
|  | uint | x,
|  | uint | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl
| ) |  |
| virtual

Assign size and position to the widget.

Parameters

  sizing | Type of resizing to perform.
  x | Horizontal offset of the widget relative to the left edge of the window.
  y | Vertical offset of the widget relative to the top edge of the window.
  given_width | Width allocated to the widget.
  given_height | Height allocated to the widget.
  rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Definition at line 1024 of file widget.cpp.

References ComputeMaxSize(), NWidgetContainer::head, NWidgetBase::next, shown_plane, NWidgetBase::smallest_x, NWidgetBase::smallest_y, ST_SMALLEST, NWidgetBase::StoreSizePosition(), and SZSP_BEGIN.

void NWidgetStacked::Draw | ( | const Window * | w | ) |
| virtual

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 1050 of file widget.cpp.

References NWidgetContainer::head, NWidgetBase::next, shown_plane, and SZSP_BEGIN.

NWidgetCore * NWidgetStacked::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| virtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `NULL` if no widget can be found.

Implements NWidgetBase.

Definition at line 1065 of file widget.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, NWidgetCore::GetWidgetFromPos(), NWidgetContainer::head, IsInsideBS(), NWidgetBase::next, NWidgetBase::pos_x, NWidgetBase::pos_y, shown_plane, and SZSP_BEGIN.

void NWidgetStacked::SetDisplayedPlane | ( | int | plane | ) |

Select which plane to show (for NWID_SELECTION only).

Parameters

  plane | Plane number to display.

Definition at line 1083 of file widget.cpp.

References shown_plane.

Referenced by TerraformToolbarWindow::OnInit(), VehicleListWindow::OnPaint(), CompanyWindow::OnPaint(), and Window::SetShaded().

void NWidgetStacked::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array
| ) |  |
| virtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.
  init_array | Initialize the `w->nested_array`.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 980 of file widget.cpp.

References NWidgetBase::fill_x, NWidgetBase::fill_y, NWidgetContainer::head, index, LeastCommonMultiple(), max(), Window::nested_array, Window::nested_array_size, NWidgetBase::next, NWidgetBase::resize_x, NWidgetBase::resize_y, shown_plane, NWidgetBase::smallest_x, NWidgetBase::smallest_y, SZSP_BEGIN, SZSP_HORIZONTAL, SZSP_VERTICAL, and Window::UpdateWidgetSize().

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp